function [L,U] = nofill(M,milu)   
%
% This function are explained in a Saad's pubblication.
%

[ n,n ] = size(M);

A = M;

for i = 2:n
   % no pivoting is performed
   for k = 1:i-1
      % if remains a pivot null, in input there is a bad matrix
      if A(k,k) == 0
         error 'There is a pivot equal to zero.'
         return
      end
      if M(i,k) ~= 0 
         A(i,k) = A(i,k)/A(k,k);
         for j = k+1:n
            if M(i,j) ~= 0 
               A(i,j) = A(i,j)-A(i,k)*A(k,j);
            end
         end
      end   
   end
end   

L = sparse(tril(A,-1))+sparse(eye(n));
U = sparse(triu(A));

return
end
